/*
 * bma180.h
 * Created on: 24.10.2011
 */
 
#ifndef BMA020_H_
#define BMA020_H_

//Adress defines for BMA020//
//=========================//
// ID and version registers

#define Chip_ID 0x00
#define Version 0x01

#define ACCXLSB 0x02
#define ACCXMSB 0x03
#define ACCYLSB 0x04
#define ACCYMSB 0x05
#define ACCZLSB 0x06
#define ACCZMSB 0x07

#define enableREG 0x15
#define enable_ADV_INT 0xD0
#define INT_Mode 0x0B
#define any_motion_INT 0x40
#define any_motion_dur 0x11
#define any_motion_thres 0x10

#define dur_1 0x00	//Anymotion Duration
#define dur_3 0x40
#define dur_5 0x80
#define dur_7 0xC0

#define CTRLREG 0x0A
#define soft_reset 0x02
#define reset_INT 0x40

#define Bw_Range 0x14
//===================//

//Range settings

#define _2g_ 0x00
#define _4g_ 0x01
#define _8g_ 0x02

#define RANGESHIFT 3		//wird bentigt um an der richtigen Stelle im Register zu schreiben
#define RANGEMASK 0x18

//Bandwidth settings

#define _25Hz_ 0x00
#define _50Hz_ 0x01
#define _100Hz_ 0x02
#define _190Hz_ 0x03
#define _375Hz_ 0x04
#define _750Hz_ 0x05
#define _1500Hz_ 0x06

#define BWMASK 0x0F
#define BWSHIFT 4			//Wird bentigt um an der richtigen Stelle im Register zu schreiben

//===Befehlsdefintionen===//

#define sbi(var,mask) ((var)|=(uint8_t)(1<<mask)) //verkrzte Schreibweise fr Bit setzen_lschen
#define cbi(var,mask) ((var)&=(uint8_t)~(1<<mask))

//===IO-Definitionen===//

#define CSB PB4		//Pin for Chip-Select
#define INT PC5
#define INT_Bit 5		//Pin for Interrupt (PD2 ist INT0 beim Atmega8)

extern void init_SPI(void);
extern void txdata(char data);
extern char rxdata(void);
extern char read(uint8_t address);
extern void write(uint8_t address,char data);
extern int init_BMA020(uint8_t range,uint8_t bw);


#endif /*BMA180_h*/
